/* Raspberry Pi DACS USBT[o[
   RPiDvSv.c    2017/11/09    _bNXZ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include "ftd2xx.h"

#include <termios.h>
#include <sys/mman.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>

int main()
{
    int p, q, r; 
    char recfs = 0, rectemp;         /* vOIwێp */

    /* USBfoCX */

    FT_STATUS   ftStatus;
    FT_HANDLE   ftHandle[16];
    int iport;
    DWORD       numDevs;
    DWORD       EEUA_Size;
    unsigned char EEUA_Data[64];
    DWORD       WriteNum, TransNum;
    DWORD       ReadNum, RecNum, EventDword;
    char        recbuf[1024];
    char        buf[65536];
    static      FT_PROGRAM_DATA Data;
    int swID;                        /* USBfoCXIDԍ({[hXCb`ݒ) */
    int swIDtable[16] = {99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99};
                                     /* {[hXCb`ݒIDԍe[u
                                        IDԍ(0`15)USB|[gԍZbg */
    int swSK;                        /* NCAgMf[^̃\Pbg(|[g)ԍ */
    int swSKtable[16];               /* IDԍ(0`15)ɉ\Pbg(|[g)ԍZbg */
    int swOCtable[16] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
                                     /* IDԍ(0`15)ɃNCAgL
                                        \Pbg(|[g)ԍZbg  -1:LȂ */
    int DevEnable = 0;               /* DACSfoCX̐ڑȂƂ1ȏ゠ */
    int dacsusbdv = 0;               /* DACSUSBfoCXL */
    const char *DacsMId = "DACS";    /* USBfoCXID */
    char DacsSNo[16][16];            /* USBfoCX VAԍ */

    /* lbg[N */

    const int socknoini = 17909;     /* \Pbgԍ擪l */
    int socka[8];
    struct sockaddr_in addr[8];
    struct sockaddr_in client[8];
    unsigned int ctlen;
    int socktr[8] = {-1,-1,-1,-1,-1,-1,-1,-1};
    unsigned int socktime[8] = {0,0,0,0,0,0,0,0};   /* ^CAEgĎ */
    int nbval = 1;

    /* LANݒt@C֘A */

    FILE *fp;
    const char *wpaconf = "/etc/wpa_supplicant/wpa_supplicant.conf";
                                     /* wireless LAN config. file */
    int wlanset = 0;                 /* wireless LAN config. file  */
    int timecnt = 0;                 /* ^CAEgJE^ */
    char fdatabuf[256][256];         /* file ݃f[^obt@ */

    /* Wo͂mubLOƂ */

    int oldf;

    oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
    fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);

    /* lbg[N T[o[̏ */
    
    for(p = 0; p != 8; p++){
        do{
            socka[p] = socket(AF_INET, SOCK_STREAM, 0); /* \Pbg̍쐬 */
        }while(socka[p] < 0);
        ioctl(socka[p], FIONBIO, &nbval);               /* mubLOɐݒ */

        addr[p].sin_family = AF_INET;                   /* \Pbg̐ݒ */
        addr[p].sin_port = htons(socknoini + p);        /* \Pbgԍ */
        addr[p].sin_addr.s_addr = INADDR_ANY;
        bind(socka[p], (struct sockaddr *)&addr[p], sizeof(addr[p]));
        listen(socka[p], 8);                            /* TCPNCAg̐ڑv҂ */
    }

    /* lbg[NUSB|[gŃf[^M */
    
    do{
        usleep(1000);                                   /* Ԃ */
        if((rectemp = getchar()) == '!') recfs = rectemp;   /* '!'L[͂̂ƂvOI */
        
        if((recfs == '!') || (recfs == '#')){           /* NCAg/L[͂vOIw */
        
            /* ׂ̃\Pbgclose */

            for(p = 0; p != 8; p++){
                if(socktr[p] >= 0){
                    close(socktr[p]);                   /* ڑς݂̃\Pbgclose */
                    socktr[p] = -1;                     /* \Pbgԍ𖳌Ƃ */
                    printf("TCP%d close\n", p);
                }
            }
        }
        for(p = 0; p != 8; p++){                        /* NCAg̐ڑmF */
            if(socktr[p] >= 0) break;
        }
        if(p == 8){                                     /* NCAg̐ڑ܂ȂƂ */
        
            /* ڑς݂USBfoCXclose */

            for(swID = 0; swID != 16; swID++){
                iport = swIDtable[swID];
                if(iport != 99){                        /* openς݂USBfoCX|[ĝƂ */
                    ftStatus = FT_Close(ftHandle[iport]);   /* USBfoCXclose */
                    printf("USB Port %d close\n", iport);
                    swIDtable[swID] = 99;               /* USBfoCXڑȂƂ */
                }
            }
            DevEnable = 0;
            if((recfs == '!') || (recfs == '#')) break; /* vOIŵƂ */
        }

        /* TCPNCAg̐ڑvt */

        for(p = 0; p != 8; p++){
            if(socktr[p] < 0){
                ctlen = sizeof(client[p]);              /* TCPNCAg̐ڑvt */
                socktr[p] = accept(socka[p], (struct sockaddr *)&client[p], &ctlen);
                if(socktr[p] >= 0){
                    ioctl(socktr[p], FIONBIO, &nbval);  /* f[^MmubLOɐݒ */
                    socktime[p] = 1;                    /* ^CAEg^C}[X^[g */
                    printf("TCP%d accept\n", p);
                }
            }
        }
        for(p = 0; p != 8; p++){                        /* NCAg̐ڑmF */
            if(socktr[p] >= 0) break;
        }
        if(p == 8) continue;                            /* NCAg̐ڑ܂ȂƂ */

        /* USBfoCX̊mF */

        if(DevEnable == 0){                             /* DACSfoCX̐ڑȂƂ */

            dacsusbdv = 0;                              /* DACSUSBfoCXLZbg */
            ftStatus = FT_ListDevices(&numDevs,NULL,FT_LIST_NUMBER_ONLY);
                                                        /* ڑfoCX擾 */
            if(numDevs > 0){
                if(numDevs > 16) numDevs = 16;          /* őڑ̐ */
                printf("FT device numbers = %d\n\n", numDevs);

                /* _CNgł𓮍\Ƃ邽߁AzCOMhCoo^͂ */

                system("modprobe -r ftdi_sio");         /* USBfoCX̐ڑȂȂƁA
                                                           ̐ڑŉzCOMɂǂ̂
                                                           foCX1ȏڑꂽƂɁA
                                                           zCOMhCo폜Kv */
                /* DACSfoCX̊mF */

                Data.Signature1 = 0x00000000;           /* EEPROMǎ惁̈m */
                Data.Signature2 = 0xffffffff;
                Data.Manufacturer = (char *)malloc(256);
                Data.ManufacturerId = (char *)malloc(256);
                Data.Description = (char *)malloc(256);
                Data.SerialNumber = (char *)malloc(256);

                for(iport = 0; iport != (int)numDevs; iport++){ /* foCX̂Ԃ */

                    for(r = 0; r != 10; r++){           /* USBfoCXOPEN */
                        usleep(10000);
                        ftStatus = FT_Open(iport,&ftHandle[iport]);
                        if(ftStatus == FT_OK) break;
                    }
                    if(ftStatus != FT_OK){              /* OPEN łȂƂ͎̃|[g */
                        printf("USB Port %d Open NG\n", iport);
                        continue;
                    }

                    /* OPEN łƂ */

                    printf("USB Port %d Open OK\n", iport);

                    /* EEPROM̓eǎ */

                    ftStatus = FT_EE_Read(ftHandle[iport], &Data);  /* EEPROM̓eǎ */

                    if(ftStatus != FT_OK) dacsusbdv = 0;            /* DACSUSBfoCXł͂ȂƂ */
                    else{
                        dacsusbdv = 0;                  /* DACSUSBfoCXł͂ȂƉ */
                        printf("VendorId = 0x%04X\n", Data.VendorId);   /* USBfoCX\ */
                        printf("ProductId = 0x%04X\n", Data.ProductId);
                        printf("Manufacturer = %s\n", Data.Manufacturer);
                        printf("ManufacturerId = %s\n", Data.ManufacturerId);
                        printf("Description = %s\n", Data.Description);
                        printf("SerialNumber = %s\n", Data.SerialNumber);
                        if(strcmp(Data.Manufacturer, DacsMId) == 0){           /* IDmF */
                            if(strlen(Data.SerialNumber) == 8){                /* VAԍmF */
                                if(Data.SerialNumber[0] == 'D') dacsusbdv = 1; /* VAԍ̐擪mF */
                            }
                        }
                        if(dacsusbdv == 1){                                    /* DACSfoCX̏ꍇ */
                            strcpy(&DacsSNo[iport][0],Data.SerialNumber);      /* VAԍi[ */
                            DacsSNo[iport][8] = 0xd;
                            ftStatus = FT_SetChars(ftHandle[iport],0x0d,1,0x0,0);  /* ؂蕶ݒ */
                            ftStatus = FT_SetTimeouts(ftHandle[iport],100,100);    /* ^CAEgԂݒ */
                            if(Data.SerialNumber[1] == '8'){                   /* DACS-8200̂߂(̼رْʐMɕKv) */
                                ftStatus = FT_SetBaudRate(ftHandle[iport],1382400);  /* ʐMxݒ */
                                ftStatus = FT_SetDataCharacteristics(ftHandle[iport],FT_BITS_8,FT_STOP_BITS_1,FT_PARITY_NONE);
                                                                               /* ʐMް`ݒ */
                                ftStatus = FT_SetFlowControl(ftHandle[iport],FT_FLOW_RTS_CTS,0,0);  /* ʐM۰ݒ */
                            }
                        }
                    }

                    /* IDԍ
                       16IDԍIR}hWR}h𑗐MmF */

                    if(dacsusbdv == 1){                 /* DACSfoCX̏ꍇ */
                        WriteNum = 9;
                        sprintf(recbuf,"I0000000 ");
                        recbuf[8] = 0xd;
                        for(swID = 0; swID != 16; swID++){
                            recbuf[1] = (char)(0x30 + swID);
                            if(recbuf[1] > 0x39) recbuf[1] = recbuf[1] + 7;
                            recbuf[0] = 'I';            /* JR}hŃs[gݒɂfoCXԂɂ邽 */
                            for(p = 0; p != 2; p++){
                                TransNum = 0;
                                ftStatus = FT_Write(ftHandle[iport],recbuf,WriteNum,&TransNum); /* f[^M */
                                usleep(20000);
                                ReadNum = 0;
                                FT_GetStatus(ftHandle[iport],&ReadNum,&TransNum,&EventDword); /* Mf[^擾 */
                                if(ReadNum > 0){
                                   ftStatus = FT_Read(ftHandle[iport],buf,ReadNum,&RecNum); /* f[^M */
                                   break;               /* ΌI */
                                }
                                recbuf[0] = 'W';        /* IR}hɑΉĂȂfoCX邽 */
                            }
                            if(p != 2) break;           /* IR}h܂WR}hɉΌI */
                        }
                        if(swID < 16){                  /* IDԍIƂ */
                            printf("DIP-SW ID = %d\n\n", swID);
                            swIDtable[swID] = iport;    /* IDԍe[uɃ|[gԍo^ */
                            DevEnable = 1;              /* ȂƂ1DACSfoCXƂ */
                        }
                        else dacsusbdv = 0;             /* vIDԍȂƂ */
                    }
                    if(dacsusbdv == 0){                 /* DACSUSBfoCXł͂ȂƂ */
                        printf("NO DACS Device\n\n");
                        ftStatus = FT_Close(ftHandle[iport]);   /* foCXclose */
                    }
                }
                free(Data.Manufacturer);                /* EEPROMǎ惁̈ */
                free(Data.ManufacturerId);
                free(Data.Description);
                free(Data.SerialNumber);
            }
        }

        /* NCAgf[^M */

        r = -1;                                         /* NCAg̎Mf[^Zbg */
        swSK = -1;                                      /* \PbgԍZbg */
        for(p = 0; p != 8; p++){
            if(socktr[p] >= 0){
                r = read(socktr[p], recbuf, 1000);      /* NCAg當f[^(R}h)M */
                if(r > 0){
                    swSK = socktr[p];                   /* \Pbg̃|[gԍ擾 */
                    socktime[p] = 1;                    /* ^CAEg^C}[X^[g */
                    break;                              /* \Pbgԍ̃NCAgD悷 */
                }
            }
        }

        /* wireless LAN config. file  */

        if((swSK == socktr[0]) && (swSK != -1)){        /* config. file ̃\Pbg͐擪ԍɌŒ */
            if((r == 3) && (recbuf[0] == '%') && (recbuf[1] == '$') && (recbuf[2] == 0xd) && (wlanset == 0)){
                wlanset = 1;                            /* wireless LAN config. Ƃ */
                buf[0] = 0x20;
                write(swSK, buf, 1);                    /* NCAgɉ𑗐M */
                timecnt = 0;                            /* ^CAEgJE^Zbg */
                usleep(20000);
                continue;
            }
            if(wlanset){                                /* wireless LAN config. ̂Ƃ */
                if(r > 0){
                    if((recbuf[0] == 0x1b) || (wlanset > 30)){
                        if((fp = fopen(wpaconf, "w")) != NULL){  /* t@C֏ */
                            for(p = 0; p != wlanset-1; p++ ) fputs(&fdatabuf[p][0], fp);
                            fclose(fp);
                        }
                        wlanset = 0;                    /* wireless LAN config.  */
                    }
                    else{
                        recbuf[r] = 0;
                        strcpy(&fdatabuf[wlanset-1][0], recbuf); /* obt@Ƀt@Cf[^Psۑ */
                        buf[0] = 0x20;
                        write(swSK, buf, 1);            /* NCAgɉ𑗐M */
                        timecnt = 0;                    /* ^CAEgJE^Zbg */
                        wlanset++;                      /* sXV */
                    }
                }
                usleep(20000);
                timecnt++;                              /* ^CAEgJE^XV */
                if(timecnt > 100) wlanset = 0;          /* wireless LAN config. file  */
                continue;
            }
        }

        /* NCAgڑIʒmƂ */

        if(r > 1){
            rectemp = recbuf[r-2];
            if(rectemp == '*'){                         /* ڑIʒm̂Ƃ */
                close(swSK);                            /* TCPZbVI */
                for(p = 0; p != 16; p++){
                    if(swOCtable[p] == swSK) swOCtable[p] = -1; /* L */
                }
                for(p = 0; p != 8; p++){
                    if(swSK == socktr[p]){
                        printf("TCP%d close\n", p);
                        socktr[p] = -1;                 /* \Pbg(|[g)ԍ𖳌Ƃ */
                        socktime[p] = 0;                /* ^CAEg^C}[~ */
                        break;
                    }
                }
                wlanset = 0;                            /* wireless LAN config. file  */
                continue;
            }
            if((rectemp == '!') || (rectemp == '#')){   /* vOIŵƂ */
                recfs = rectemp;                        /* vOIwZbg */
                continue;
            }
        }
        
        /* NCAgڑmFƂ */

        if((r == 2) && (recbuf[0] == 0x1c)){
            buf[0] = 0x1d;
            buf[1] = 0xd;
            write(swSK, buf, 2);                        /* NCAgɃX|X𑗐M */
            continue;
        }

        /* NCAgUSBfoCXڑ󋵂̊mFƂ */

        if((r == 2) && (recbuf[0] == '?') && (recbuf[1] == 0xd)){
            for(p = 0; p != 16; p++){
                if(swIDtable[p] < 10) buf[p] = '1';
                else                  buf[p] = '0';
            }
            buf[16] = 0xd;
            write(swSK, buf, 17);                       /* NCAgɃX|X𑗐M */
            continue;
        }

        /* NCAgMf[^USBfoCXɑM */

        if(DevEnable){                                  /* ȂƂ1DACSfoCX */

            if(r > 2){                                  /* NCAgMf[^ */
                iport = 99;                             /* USB|[gԍɖȔԍƂ */
                swID = recbuf[1] - 0x30;                /* NCAgMIDԍmF */
                if(swID > 9) swID = swID -7;
                if((swID >= 0) && (swID < 16)){
                    p = r;                              /* Mۑ */
                    if(r > 3){
                        if((recbuf[r-4] == '$') && (recbuf[r-1] == 0xd)){
                                                        /* L܂͐L? */
                            buf[1] = recbuf[r-3];
                            buf[2] = recbuf[r-2];
                            if(r == 4) r = 0;
                            if(r > 4){
                                if((recbuf[r-5] == 0xd) || (recbuf[r-5] == '&')) r = r - 4;
                            }
                        }
                    }
                    if(p != r){                         /* L܂͐L̂Ƃ */
                        buf[0] = '$';
                        buf[3] = 0xd;
                        if((swOCtable[swID] == -1) || (swOCtable[swID] == swSK)){
                                                        /* ̃NCAgLĂȂƂ */
                            if(buf[2] == '1') swOCtable[swID] = swSK;   /* L */
                            else              swOCtable[swID] = -1;     /* L */
                        }
                        else buf[2] = '0';              /* ̃NCAgLĂƂ */

                        write(swSK, buf, 4);            /* NCAgɐL󋵂𑗐M */
                        if(r == 0) continue;
                    }
                    
                    /* ʏf[^̏ */
                    
                    if((swOCtable[swID] == -1) || (swOCtable[swID] == swSK))
                        iport = swIDtable[swID];        /* ̃NCAgLĂȂƂ
                                                               YIDԍUSB|[gԍ擾 */
                }
                if(iport == 99) continue;               /* YIDԍUSBfoCXȂƂA
                                                               ܂́ÃNCAgLĂƂ
                                                               Ȍ̏Ȃ */
                swSKtable[swID] = swSK;                 /* \Pbg(|[g)ԍe[uɃZbg */

                /* EEPROM f[^ǎŵƂ */

                if((r == 4) && (recbuf[0] == '?')){
                    if((recbuf[2] == 'S') && (recbuf[3] == 0xd)){ /* VAԍ⍇̂Ƃ */
                        write(swSK, &DacsSNo[iport][0], 9);  /* NCAgɃVAԍ(X|X)𑗐M */
                        continue;
                    }
                    if((recbuf[2] == 'E') && (recbuf[3] == 0xd)){ /* EE-PROM [UGATCY⍇̂Ƃ */
                        ftStatus = FT_EE_UASize(ftHandle[iport],&EEUA_Size); /* EE-PROM [UGATCYގ擾 */
                        sprintf(buf,"%08X", (int)EEUA_Size);
                        buf[8] = 0xd;
                        write(swSK, buf, 9);            /* NCAgɃ[UGATCY(X|X)𑗐M */
                        continue;
                    }
                    if((recbuf[2] >= '0') && (recbuf[2] < '8') && (recbuf[3] == 0xd)){    /* EE-PROM [UGAf[^⍇̂Ƃ */
                        if(recbuf[2] == '0'){
                            for(p = 0; p != 64; p++) EEUA_Data[p] = 0;
                            ftStatus = FT_EE_UASize(ftHandle[iport],&EEUA_Size);          /* EE-PROM [UGATCY擾 */
                            p = (int)EEUA_Size;
                            if(p > 64) p = 64;
                            ftStatus = FT_EE_UARead(ftHandle[iport],EEUA_Data,p,&RecNum); /* EE-PROM [UGAf[^擾 */
                        }
                        q = ((int)(recbuf[2] - 0x30)) * 8;
                        for(p = 0; p != 8; p++) sprintf(&buf[p*2], "%02X", EEUA_Data[q+p]);
                        buf[16] = 0xd;
                        write(swSK, buf, 17);           /* NCAgɃ[UGAf[^(X|X)𑗐M */
                        continue;
                    }
                }

                /* ʏf[^̂Ƃ */

                WriteNum = r;                           /* USBfoCXɃf[^M */
                TransNum = 0;
                ftStatus = FT_Write(ftHandle[iport],recbuf,WriteNum,&TransNum);
            }

            usleep(5000);                               /* USBfoCX̃f[^҂(Ԃ) */

            /* USBfoCXf[^MNCAgɑM */

            for(swID = 0; swID != 16; swID++){
                iport = swIDtable[swID];
                if(iport == 99) continue;               /* IDɊYfoCXڑȂ */
                if(swSKtable[swID] < 0) continue;       /* IDɊY鉞̃\PbgȂ */
                
                ReadNum = 0;
                ftStatus = FT_GetStatus(ftHandle[iport],&ReadNum,&TransNum,&EventDword); /* Mf[^擾 */
                if(ReadNum == 0) continue;
                ftStatus = FT_Read(ftHandle[iport],buf,ReadNum,&RecNum);  /* f[^M */
                
                if(ftStatus == FT_OK){
                    p = (int)RecNum;
                    write(swSKtable[swID], buf, p);     /*NCAgɑM */
                    for(q = 0; q != 8; q++){
                        if(socktr[q] == swSKtable[swID]) socktime[q] = 1; /* ^CAEg^C}[X^[g */
                    }
                }
            }
        }
        
        /* \Pbg̃^CAEgĎ */
        
        for(p = 0; p != 8; p++){
            if(socktime[p]) socktime[p]++;              /* ^CAEg^C}[XV */
            if(socktime[p] > 60000){                    /* USBfoCXڑƂ 6B Ȃ̂Ƃ 1 */
                printf("TCP%d timeout close\n", p);
                socktr[p] = -1;                         /* \Pbg(|[g)ԍ𖳌Ƃ */
                socktime[p] = 0;                        /* ^CAEg^C}[~ */
            }
        }

    }while(1);

    /* I */

    for(p = 0; p != 8; p++) close(socka[p]);       /* listen socketI */
    fcntl(STDIN_FILENO, F_SETFL, oldf);            /* Wo͂ ɖ߂ */
    system("modprobe ftdi_sio");                   /* zCOMhCoo^
                                                      ftHgɂǂ */
    if(recfs == '#') system("shutdown -h now");    /* NCAgVbg_Ew肪Ƃ */
    return(0);
}
